__DO_NOT_ERASE_DEBRIEF_LOG__ = false;

-- добавлять коды команд в тултип для команды
OPTIONS_ADD_COMMAND_CODES_TO_TOOLTIP = false

guiBindPath = './dxgui/bind/?.lua;' .. 
              './dxgui/loader/?.lua;' .. 
              './dxgui/skins/skinME/?.lua;' .. 
              './dxgui/skins/common/?.lua;'

package.path = 
       ''
    .. guiBindPath
    .. '.\\MissionEditor\\?.lua;'
    .. '.\\MissionEditor\\themes\\main\\?.lua;'
    .. '.\\MissionEditor\\modules\\?.lua;'	
    .. '.\\Scripts\\?.lua;'
    .. '.\\LuaSerializer\\?.lua;'
    .. '.\\LuaSocket\\?.lua;'
	.. '.\\Scripts\\UI\\?.lua;'    -- для debriefing

    
-- загружаем новый скин
local function loadSkin()
  skinPath = './dxgui/skins/skinME/'
  dofile(skinPath .. 'skin.lua')
end

hookLog 				= {}    
START_PARAMS.command    = 'quit'
main_w                  = 1024
main_h                  = 768
defaultReturnScreen     = 'mainmenu'
tempMissionName         = 'tempMission.miz'
trackFileName           = 'LastMissionTrack.trk'
watchTrackFileName      = '_LastMissionTrack.trk'
mainPath				= 'MissionEditor/'
themesPath          = mainPath   .. 'themes/'
imagesPath          = themesPath .. 'main/images/'

-- START_PARAMS.returnScreen = 'LOFAC'

LOFAC = ('LOFAC' == START_PARAMS.returnScreen)

__STEAM__ = false
DEBUG = true

function hookFcn(event, lineNumber)
    local functionFilter = {
        ['unpack'] = true,
        ['xpcall'] = true,
        ['member'] = true,
        ['type'] = true,
        ['time'] = true,
        ['date'] = true,
        ['remove'] = true,
        ['isVisible'] = true,
        ['setText'] = true,
        ['(for generator)'] = true,
        ['old_pairs'] = true,
    }
    local info = debug.getinfo(2)
    local fun = info.name or ''
    if string.find(info.short_src, 'me_traceback') then
        return
    end
    if functionFilter[fun] then
        return
    end
    local counter = 3
    local tabString = ''
    local _info = {}
    while _info ~= nil do        
        tabString = tabString .. '  '
        _info = debug.getinfo(counter)
        counter = counter + 1
    end
    print(tabString .. info.short_src .. ' in line ' .. info.currentline .. ' in func: ' .. fun)
end 

local textutil = require('textutil')

local old_sort = table.sort
table.sort = function(tbl, fun)
    if (type(tbl[1]) == 'string') and (fun == nil) then
        old_sort(tbl, function(op1, op2) return textutil.Utf8Compare(op1, op2) end)
    else
        old_sort(tbl, fun)
    end
end

os.execute('del /F /Q *.tmp >nul 2>nul')
os.execute('cls')

lfs = require('lfs')  -- Lua File System
local T = require('tools')
local ImageSearchPath = require('image_search_path')

absolutPath			= lfs.currentdir()
simPath	 			= './' -- путь к корневой папке симулятора
missionDir			= lfs.writedir() .. 'Missions/'
moviesDir			= lfs.writedir() .. 'Movies/'
userDataDir			= lfs.writedir() .. 'MissionEditor/'
tempDataDir			= lfs.tempdir()
liveriesDir         = lfs.writedir() .. 'Liveries/'
configPath 			= lfs.writedir() .. 'Config/'
tempMissionPath 	= tempDataDir .. 'Mission/' -- путь к временной папке ресурсов миссий
tempCampaignPath 	= tempDataDir .. 'Campaign/' -- путь к временной папке ресурсов миссий
dialogsDir 			= mainPath   .. 'modules/dialogs/' -- путь к диалогам
userFiles 			= T.safeDoFileWithRequire(simPath .. 'Scripts/UserFiles.lua')
--configHelper 		= T.safeDoFileWithRequire(simPath .. 'Scripts/ConfigHelper.lua')    

--__KA50_VERSION__ = true
--__HUMAN_PLANE__ = true
--__FINAL_VERSION__ = true
--__A10C_VERSION__ = true

--__BETA_VERSION__ = true

--print("*****__FINAL_VERSION__=",__FINAL_VERSION__)
--print("*****__A10C_VERSION__=",__A10C_VERSION__)  

local function loadInternationalization()
  i18 = require('i18n')

  i18.setLocale(simPath .. "l10n")
  i18.gettext.add_package("input")
  i18.gettext.add_package("inputEvents")
  i18.gettext.add_package("payloads")

  -- ЗАГРУЗКА ПЕРЕВОДОВ ИЗ ПЛАГИНОВ 	
	local function loadTranslatePlugins(a_path)
		for dir in lfs.dir(a_path) do
			local fullNameDir  = a_path .. '/' .. dir
			local d = lfs.attributes(fullNameDir)
			if (d and (d.mode == 'directory') and (dir ~= '.') and (dir~='..')) then
				local ldir = lfs.attributes(fullNameDir.. '/l10n')
				if (ldir and (ldir.mode == 'directory')) then
					i18.gettext.add_package("messages", simPath .. '/' .. fullNameDir.. '/'.. "l10n")
				end
			end
		end
	end
	
	loadTranslatePlugins("Mods/aircrafts")
	loadTranslatePlugins("Mods/tech")
end

loadInternationalization() -- НЕ ПЕРЕНОСИТЬ !

-- fall back to default locale
os.setlocale("C")
os.setlocale("","time")

local function loadTheme()
  -- загрузка темы для GUI
  -- путь к папке с темами GUI
  themesPath = mainPath .. 'themes/'
end

MAX_TEXTURE_SIZE = 2048

local function loadDatabase()
  me_db = require('me_db_api')
  me_db.create() -- чтение и обработка БД редактора
  
end

local function loadOptions()
  panel_options = require('me_options')
  panel_options.loadOptions()
end

local function getScreenParams()
  local width = panel_options.vdata.graphics.width.__value__
  local height = panel_options.vdata.graphics.height.__value__
  local fullscreen = panel_options.vdata.graphics.fullScreen.__value__
  
  local screen_w, screen_h = Gui.GetCurrentVideoMode()
  
  if screen_w <= width or screen_h <= height then
      fullscreen = true
  end  
  
  if fullscreen then 
      width = 2560
      height = 1440
  end
  
  return width, height, fullscreen
end

local function createWaitScreen()
  -- Заставка с прогресс-баром
  wait_screen = require('me_wait_screen')
  wait_screen.create(0, 0, main_w, main_h)
end

function loadOneOrAnother(a_path1, a_path2, a_noShowError)
    local a, errA = lfs.attributes(a_path1)
    local b, errB = lfs.attributes(a_path2)
    local result
    if (a and a.mode == 'file')  then
        result = loadfile(a_path1) 
    elseif (b and b.mode == 'file') then
        result = loadfile(a_path2) 
    elseif a_noShowError ~= true then
        print("ERROR: loadOneOrAnother: OpenFile(" .. a_path1 .. " or " .. a_path2 .. "): The system cannot find the path specified.")
    end
    return result
end

local function createGUI()  
  local width, height, fullscreen = getScreenParams()
  
  -- создаем окно приложения  
  Gui.CreateWindow(width, height, fullscreen)
  Gui.SetWaitCursor(true)	
  -- инициализация рендера должна быть выполнена до вызова Gui.Create()
  dxgui.CreateEdgeRender('dxgui_edge_render.dll', './MissionEditor/gui.fx', './Config/missionEditor.cfg')
  Gui.CreateGUI('./dxgui/skins/skinME/skin.lua')
  
  ImageSearchPath.pushPath(imagesPath)
  
  if (LOFAC) then
      local locale = i18n.getLocale()
      
      if locale == 'ru' then 
        Gui.SetBackground('./MissionEditor/themes/main/images/lofac/loading-window_RU.png')
        Gui.SetWindowText('СПО-НОПП')
      else
        Gui.SetBackground('./MissionEditor/themes/main/images/lofac/loading-window.png')
        Gui.SetWindowText('JFT')
      end
      
      ImageSearchPath.pushPath(imagesPath .. '/lofac')
  else    
    Gui.SetBackground('./MissionEditor/themes/main/images/loading-window.png')
    Gui.SetWindowText('Digital Combat Simulator')
  end
  
  Gui.Redraw()
  Gui.SetFramerate(50)
  
	if LOFAC then
		Gui.SetIcon(mainPath..'../FUI_FAC/LOFAC.ico')
 --   elseif __KA50_VERSION__  then
 --       Gui.SetIcon(mainPath..'../FUI/BS-1.ico')
    else
        Gui.SetIcon(mainPath..'../FUI/DCS-1.ico')
    end
	
end

local function createUsersDirs()
	lfs.mkdir(userDataDir)
	lfs.mkdir(configPath)
	lfs.mkdir(tempDataDir)
	lfs.mkdir(tempMissionPath)
	lfs.mkdir(tempCampaignPath)
    lfs.mkdir(moviesDir)
	
	lfs.mkdir(userFiles.userMissionPath)
	lfs.mkdir(userFiles.userCampaignPath..'\\en')
	lfs.mkdir(userFiles.userCampaignPath..'\\ru')
	lfs.mkdir(userFiles.userTrackPath)
end

function createProgressBar()
	StartProgressBar = require('StartProgressBar')
	StartProgressBar.create(0, 0, main_w, main_h)
	Gui.Redraw()
end

local function addPathTex()
    ImageSearchPath.pushPath("MissionEditor/data/images/Loadout/Units")
    ImageSearchPath.pushPath("MissionEditor/data/images/Loadout/Weapon")
    
    for k,v in pairs(plugins) do
        local pathTex = v.dirName.."/".."ImagesGui/"
        local a, err = lfs.attributes(pathTex)
        if a and a.mode == 'directory' then
            ImageSearchPath.pushPath(pathTex)
        end
    end    
end

loadSkin()

Gui = require('dxgui')
GuiWin = require('dxguiWin')

setmetatable(dxgui, {__index = dxguiWin})

createUsersDirs()

loadTheme()
loadDatabase()  
loadOptions()
createGUI() 

-- поскольку fullscreen у нас не настоящий, то после вызова Gui.Create() нужно вызвать 
-- Gui.GetWindowSize(), который вернет настоящие размеры окна (для fullscreen это разрешение десктопа)
main_w, main_h = Gui.GetWindowSize()
createProgressBar()
StartProgressBar.setValue(1)
createWaitScreen()
StartProgressBar.setValue(5)
-- start music
music = require('me_music')
music.init('./Sounds', './Sounds/sdef')
music.setMusicVolume(panel_options.vdata.sound.music.__value__)
music.setEffectsVolume(panel_options.vdata.sound.gui.__value__)

StartProgressBar.setValue(9)
panel_options.create(0, 0, main_w,  main_h)

StartProgressBar.setValue(10)

-- Создание главного меню
mmw = require('MainMenu')
mmw.create(0, 0, main_w, main_h)

addPathTex()
mmw.setLastWallpaper()

-- Создание модулей
----Загружаем информацию о картах---------------------------
loaderMaps = require('loaderMaps')
--local dir = i18n.getLocalizedDirName(simPath .. 'TheatresOfWar/')  
local dir = simPath .. 'TheatresOfWar/'  
	
loaderMaps.loadDir(dir)	
StartProgressBar.setValue(11)

-- Модуль edTerrain - это библиотека Робустова из проекта Black Shark.
-- Она обеспечивает доступ к отображаемому на память файлу модели 
-- земной поверхности Land.lsa2 и позволяет получать высоту местности
-- в заданной точке карты.
-- В библиотеку edTerrain специально внесены изменения в интересах
-- данного проекта, чтобы обеспечить доступ к ней из Lua.
-- В данном проекте эта библиотека называется lua-edTerrain.dll.
-- Поскольку она зависит от библиотек Common.dll и Math.dll, эти
-- библиотеки также включены в данный проект.


Terrain = require('edTerrain')


Gui.SetGCFramesCount(40)

MapWindow = require('me_map_window')
menubar = require('me_menubar')
toolbar = require('me_toolbar')
statusbar = require('me_statusbar')
panel_coalitions = require('me_coalitions')
panel_manager_resource = require('me_manager_resource')
panel_aircraft = require('me_aircraft')
panel_ship = require('me_ship')
panel_vehicle = require('me_vehicle')
panel_summary = require('me_summary')
panel_SCR522 = require('me_panelSCR522')
panel_suppliers = require('me_suppliers')
panel_triggered_actions = require('me_triggered_actions')
panel_targeting = require('me_targeting')
panel_route = require('me_route')
panel_wpt_properties = require('me_wpt_properties')
panel_actions = require('me_action_edit_panel')
panel_action_condition = require('me_action_condition')
panel_loadout = require('me_loadout')
panel_payload = require('me_payload')
panel_fix_points = require('me_fix_points')
panel_nav_target_points = require('me_nav_target_points')
panel_static = require('me_static')
panel_warehouse = require('me_warehouse')
panel_navpoint = require('me_navpoint')
panel_bullseye = require('me_bullseye')
panel_weather = require('me_weather')
panel_map_options = require('me_map_options')
panel_mis_options = require('me_misoptions')
module_mission = require('me_mission')
panel_briefing = require('me_briefing')
panel_autobriefing = require('me_autobriefing')
panel_debriefing = require('me_debriefing')
panel_openfile = require('me_openfile')
panel_record_avi = require('record_avi')
panel_failures = require('me_failures')
panel_enc = require('me_encyclopedia')
panel_about = require('me_about')
panel_goal = require('me_goal')
panel_roles = require('me_roles')
MGModule = require('me_generator')
module_updater =  require('me_updater')

StartProgressBar.setValue(12)

GDData = require('me_generator_dialog_data')
GDData.initData()
nodes_manager = require('me_nodes_manager')
nodes_manager.initNodes()
templates_manager = require('me_templates_manager')
templates_manager.initData()

panel_trigrules = require('me_trigrules')
panel_zone = require('me_trigger_zone')
panel_template = require('me_template')
panel_training = require('me_training')
panel_logbook = require('me_logbook')
panel_campaign = require('me_campaign')
panel_units_list = require('me_units_list')
panel_trig_zones_list = require('me_trig_zones_list')
panel_campaign_editor = require('me_campaign_editor')
panel_campaign_end = require('me_campaign_end')
exit_dialog = require('me_exit_dialog')
mod_copy_paste = require('me_copy_paste')
videoPlayer = require("me_video_player")
panel_news = require('me_news')
panel_infoPlugin = require('me_infoPlugin')
panel_modulesmanager = require('me_modulesmanager')

local planner_mission = false

U = require('me_utilities')

-- Фиксированные размеры панелей Редактора миссий
top_toolbar_h = U.top_toolbar_h
left_toolbar_w = U.left_toolbar_w
bottom_toolbar_h = U.bottom_toolbar_h
right_toolbar_width = U.right_toolbar_width
map_w = main_w - left_toolbar_w
local right_toolbar_h = U.right_toolbar_h
actions_toolbar_w = U.actions_toolbar_w
condition_bar_h = right_toolbar_h - 28
actions_bar_h = main_h - top_toolbar_h - bottom_toolbar_h  - condition_bar_h


function loadPanels(endProgressValue)
	local panelInfo = {}
	
	local addPanelInfo = function(panel, x, y, w, h)		
		table.insert(panelInfo, function() panel.create(x, y, w, h) end)
	end
	
	local right_panel_height = main_h - top_toolbar_h - bottom_toolbar_h
	local right_bottom_panel_height = right_panel_height  - right_toolbar_h
	local right_panel_x = main_w - right_toolbar_width
	local right_panel_y = top_toolbar_h
	local right_bottom_panel_y = top_toolbar_h + right_toolbar_h

	addPanelInfo(panel_modulesmanager, 0, 0, main_w, main_h)
	addPanelInfo(MapWindow, left_toolbar_w, top_toolbar_h, main_w - left_toolbar_w, right_panel_height)
	addPanelInfo(menubar,  0, 0, main_w, top_toolbar_h )
	addPanelInfo(toolbar,  0, top_toolbar_h, left_toolbar_w, right_panel_height)
	addPanelInfo(panel_briefing, right_panel_x, right_panel_y, right_toolbar_width, right_panel_height)
	addPanelInfo(panel_openfile, main_w - 390, 0, 390, main_h)
	addPanelInfo(panel_record_avi, right_panel_x, right_panel_y, right_toolbar_width, right_panel_height)
	addPanelInfo(panel_enc, 0, 0,  main_w, main_h)
	addPanelInfo(panel_about, right_panel_x, right_panel_y, right_toolbar_width, right_panel_height) 
	addPanelInfo(panel_failures, main_w - 650, right_bottom_panel_y, 650,  right_panel_height - right_toolbar_h) 
	addPanelInfo(panel_weather, right_panel_x, right_panel_y, right_toolbar_width, right_panel_height) 
	addPanelInfo(panel_training, 0, 0, main_w, main_h)
	addPanelInfo(panel_campaign_editor, 0, 0, main_w, main_h)
	addPanelInfo(statusbar, 0, main_h-bottom_toolbar_h, main_w, bottom_toolbar_h)
	addPanelInfo(panel_map_options, right_panel_x, right_panel_y, right_toolbar_width, right_panel_height) 
	addPanelInfo(panel_logbook, 0, 0, main_w, main_h)
	addPanelInfo(panel_mis_options, right_panel_x, right_panel_y, right_toolbar_width, right_panel_height) 
	addPanelInfo(panel_campaign, right_panel_x, right_panel_y, right_toolbar_width, right_panel_height)
	addPanelInfo(panel_summary, right_panel_x, right_bottom_panel_y, right_toolbar_width, right_bottom_panel_height)
	addPanelInfo(panel_SCR522, right_panel_x, right_bottom_panel_y, right_toolbar_width, right_bottom_panel_height)
	addPanelInfo(panel_suppliers, right_panel_x, right_bottom_panel_y, right_toolbar_width, right_bottom_panel_height)
	addPanelInfo(panel_triggered_actions, right_panel_x, right_bottom_panel_y, right_toolbar_width, right_bottom_panel_height)
	addPanelInfo(panel_targeting, right_panel_x, right_bottom_panel_y, right_toolbar_width, right_bottom_panel_height)
	addPanelInfo(panel_route, right_panel_x, right_bottom_panel_y, right_toolbar_width, right_bottom_panel_height)
	addPanelInfo(panel_wpt_properties, right_panel_x, right_bottom_panel_y, right_toolbar_width, right_bottom_panel_height)
	addPanelInfo(panel_actions, right_panel_x - actions_toolbar_w, main_h - bottom_toolbar_h - actions_bar_h, right_toolbar_width,  actions_bar_h)		
	addPanelInfo(panel_action_condition, right_panel_x - actions_toolbar_w, main_h - bottom_toolbar_h - actions_bar_h - condition_bar_h, right_toolbar_width, condition_bar_h)
	addPanelInfo(panel_loadout, left_toolbar_w, top_toolbar_h, main_w - left_toolbar_w - right_toolbar_width, right_panel_height)
	addPanelInfo(panel_payload, right_panel_x, right_bottom_panel_y, right_toolbar_width,  right_bottom_panel_height)
	addPanelInfo(panel_fix_points, right_panel_x, right_bottom_panel_y, right_toolbar_width,  right_bottom_panel_height)
	addPanelInfo(panel_nav_target_points, right_panel_x, right_bottom_panel_y, right_toolbar_width, right_bottom_panel_height)
	addPanelInfo(panel_aircraft, right_panel_x, right_panel_y, right_toolbar_width, right_toolbar_h)
	addPanelInfo(panel_ship, right_panel_x, right_panel_y, right_toolbar_width, right_toolbar_h)
	addPanelInfo(panel_vehicle, right_panel_x, right_panel_y, right_toolbar_width, right_toolbar_h)
	addPanelInfo(panel_static, right_panel_x, right_panel_y, right_toolbar_width, right_panel_height)
	addPanelInfo(panel_warehouse, right_panel_x, right_panel_y, right_toolbar_width, right_panel_height)
	addPanelInfo(panel_manager_resource, main_w - 980+left_toolbar_w+1, top_toolbar_h, 980-left_toolbar_w-1-right_toolbar_width, right_panel_height)
	addPanelInfo(panel_navpoint, right_panel_x, right_panel_y, right_toolbar_width, right_panel_height)	
	addPanelInfo(panel_bullseye, right_panel_x, right_panel_y, right_toolbar_width, right_panel_height)
	addPanelInfo(panel_goal, right_panel_x, right_panel_y, right_toolbar_width, right_panel_height) 
	addPanelInfo(panel_roles, right_panel_x, right_panel_y, right_toolbar_width, right_panel_height) 
	addPanelInfo(panel_trigrules, 0, top_toolbar_h, main_w,  right_panel_height) 
	addPanelInfo(panel_zone, right_panel_x, top_toolbar_h, right_toolbar_width,  right_panel_height) 
	addPanelInfo(panel_template, right_panel_x, top_toolbar_h, right_toolbar_width,  right_panel_height) 
	addPanelInfo(panel_units_list, left_toolbar_w, main_h - bottom_toolbar_h - 300, right_panel_x - left_toolbar_w,  300)
	addPanelInfo(panel_trig_zones_list, left_toolbar_w, main_h - bottom_toolbar_h - 300, right_panel_x - left_toolbar_w,  300)
	addPanelInfo(panel_campaign_end, 0, 0, main_w, main_h)
	
	local infoCount = #panelInfo
	local progressValue = StartProgressBar.getValue()
	local progressDelta = (endProgressValue - progressValue) / infoCount
	
	for i, func in ipairs(panelInfo) do
		func()
		progressValue = progressValue + progressDelta
		StartProgressBar.setValue(math.floor(progressValue))
	end
end

function loading()
    module_updater.init()
    
	loadPanels(90)
	
    templates_manager.init(0, top_toolbar_h, main_w,  right_panel_height)
	StartProgressBar.setValue(91)	
	
    nodes_manager.setParams(0, top_toolbar_h, main_w,  right_panel_height) 
	StartProgressBar.setValue(92)    
	
    module_mission.create()
	StartProgressBar.setValue(95)	
    
    function trimQuotes(str)
        if string.find(str, '^"') and string.find(str, '"$') then
            local res = string.sub(str, 2, -2)
            return res
        else
            return str
        end        
    end
    
    local realMissionName
    START_PARAMS.missionPath = trimQuotes(START_PARAMS.missionPath)
    if START_PARAMS.missionPath and ('' ~= START_PARAMS.missionPath) then

        realMissionName = START_PARAMS.realMissionPath
        realMissionName = trimQuotes(realMissionName or '')
        module_mission.load(START_PARAMS.missionPath, true) -- надо грузить временную миссию, так как туда записано имя пилота из логбука
        module_mission.mission.path = realMissionName
		MISSION_PATH = realMissionName
        statusbar.setFileName(U.extractFileName(realMissionName))
    else
        local path = tempDataDir .. tempMissionName
        print('removing', path)
        os.remove(path)
        module_mission.clearTempFolder()
    end
 
StartProgressBar.setValue(100)
 
    if '' == START_PARAMS.returnScreen then 
        mmw.show(true)
    elseif START_PARAMS.returnScreen == 'training' then
        module_mission.create_new_mission()
        panel_training.show(true, realMissionName)
    elseif 'prepare' == START_PARAMS.returnScreen  then
        if realMissionName == nil then
            print('realMissionName == nil')
            return
        end
        module_mission.copyMission(realMissionName, START_PARAMS.missionPath)
        module_mission.load(realMissionName, true)
        
        MapWindow.show(true)
        menubar.show(true)
        toolbar.show(true)
        statusbar.show(true)
	elseif 'record_avi' == START_PARAMS.returnScreen then
		module_mission.create_new_mission()
		MapWindow.show(true)
		menubar.show(true)
		toolbar.show(true)
		statusbar.show(true)
		panel_record_avi.show(true)
    elseif 'LOFAC' == START_PARAMS.returnScreen  then
        if START_PARAMS.missionPath ~= '' then
            panel_debriefing.returnScreen = START_PARAMS.returnScreen
            panel_debriefing.show(true)
        else
            MapWindow.show(true)
            menubar.show(true)
            toolbar.show(true)
            statusbar.show(true)
        end
    elseif 'LoadAndBriefing' == START_PARAMS.returnScreen  then
        local path = START_PARAMS.missionPath  
        START_PARAMS.returnScreen = ""
        
        mmw.show(false)        
        toolbar.setOpenButtonState(false)
        statusbar.t_file:setText(U.extractFileName(path))
        wait_screen.show(true)
            panel_autobriefing.missionFileName = path
            panel_autobriefing.returnToME = false
            -- грузим миссию без редактора
            if module_mission.load(path, true) then
                panel_autobriefing.show(true, 'openmission')
            else
                mmw.show(true) 
            end

        wait_screen.show(false)
    else
        panel_debriefing.returnScreen = START_PARAMS.returnScreen
        panel_debriefing.show(true)
    end
end

function setPlannerMission(pm)
	planner_mission = pm
end

function isPlannerMission()
	return planner_mission
end

local UpdateManager = require('UpdateManager')

UpdateManager.add(music.update)
UpdateManager.add(Terrain.task_results)

-- Данная функция будет вызываться на каждом кадре отрисовки GUI.
Gui.SetUpdateCallback(UpdateManager.update)

function restartME()
    START_PARAMS.command = ''
    START_PARAMS.missionPath = ''
    if LOFAC == true then
        START_PARAMS.returnScreen = 'LOFAC'
        RETURN_SCREEN = 'LOFAC'
    else
        START_PARAMS.returnScreen = ''
        RETURN_SCREEN = ''
    end
    MISSION_PATH = ''
    Gui.doQuit()    
end 

local pressedKeys = {}

function collectMELoggingKeys(key, keyState)
  if 'left ctrl' == key or 'left shift' == key or 'left alt' == key or 'l' == key then
    if 'down' == keyState then
      pressedKeys[key] = true
    else
      pressedKeys[key] = false
    end
  end   
end

function processMELogging(key, keyState)  
  -- left ctrl + L - turn on log
  -- left ctrl + left shift + L - turn off log
  -- left ctrl + left shift + left alt + L - open log
  collectMELoggingKeys(key, keyState)
  
  if 'down' == keyState then
    if pressedKeys['left ctrl'] and pressedKeys['l'] then
      if pressedKeys['left shift'] then
        if pressedKeys['left alt'] then
          openLog()
        else
          turnLog(false)
        end
      else
        turnLog(true)
      end
    end
  end
end

-- все события от кнопок сначала попадают сюда
Gui.SetKeyboardCallback(processMELogging)

function writeLog()
    turnLog(false)
    if #hookLog >0 then
        local date = os.date()
        date = string.gsub(date, '[/:]','-')
        local logName = './temp/MissionEditor-' .. date ..'.log'
        print('saving log', logName)
        local f, err = io.open(logName, 'w')
        if f == nil then
            print(err)
        end

        for i, rec in ipairs(hookLog) do
            f:write(rec..'\n') 
        end

        f:close()
    end    
end 

function turnLog(b)
    print('turning log', b)
    
    if b then
        debug.sethook ( hookFcn, 'c' )
        --profiler.start()
    else
        debug.sethook ( )
        --profiler.stop()
    end
end

function openLog()
  print('openLog()')
  
  local folder = lfs.writedir() .. 'Logs'

  os.execute(string.format('explorer "%s"', folder))
end

function onQuit()
  if exit_dialog.show() then
    MapWindow.show(false)
    Gui.doQuit()
  end
end 

Gui.SetQuitCallback(onQuit)

function Gui.doQuit()  
  local Input = require('Input')  
  
  Input.uninitialize()  
  MGModule.saveAll()
  
  if Terrain then
	 Terrain.Release()
  end
  Gui.Quit()
end

function backupTrackMission()
    local dir = 'temp\\history'
    if not lfs.dir(dir)() then
        print('creating history dir '..dir)
        local res, err = lfs.mkdir(dir)
        print('lfs: ',res, err)
    end
    
    local timeTbl = os.date('*t')
    local timeStr = tostring(timeTbl.month) .. '-' .. tostring(timeTbl.day) ..
        '-' .. tostring(timeTbl.hour) .. '-' .. tostring(timeTbl.min) .. 
        '-' .. tostring(timeTbl.sec)

    local source = 'temp\\' .. tempMissionName
    local dest = dir .. '\\tempMission_' .. timeStr .. '.miz'
    local str = string.format('copy %s %s >> nul', source, dest)
    print(str)
    os.execute(str)
    
    local source = 'temp\\' .. trackFileName
    local dest = dir .. '\\LastMissionTrack_' .. timeStr .. '.trk'
    local str = string.format('copy %s %s >> nul', source, dest)
    print(str)
    os.execute(str)
    --mission:close()

    local source = 'temp\\debrief.log'
    local dest = dir .. '\\debrief_' .. timeStr .. '.log'
    local str = string.format('copy %s %s >> nul', source, dest)
    print(str)
    os.execute(str)
end 

panel_news:updateNews()

function createListsUnitsPlugins()

	botsLAInPlugins = {} 
	enableModules = {}
	for k,v in pairs(plugins) do
		enableModules[v.id] = v.applied
		for kk,vv in pairs(v.units.aircrafts) do
			if (botsLAInPlugins[vv.name] == nil) then
				botsLAInPlugins[vv.Name] = v.id
			else
				print("ERROR conflict name:", vv.name,v.id)
			end		
		end
	end

	technicsInPlugins = {}
	for k,v in pairs(plugins) do	
		for kk,vv in pairs(v.units.technics) do
			if (botsLAInPlugins[vv.name] == nil) then
				technicsInPlugins[vv.Name] = v.id
			else
				print("ERROR conflict name:", vv.name,v.id)
			end	
		end
	end
end
	
createListsUnitsPlugins()
 
loading()

-- выгружаем картинку задника
Gui.SetBackground()
Gui.SetWaitCursor(false)
--Gui.EnableDebugDraw(true)  -- DEBUG

StartProgressBar.kill()

Gui.Run()

writeLog()
